Subject: Re: [PATCH 3/3] index-pack: commit tree during outgoing link check

From: Junio C Hamano <[email-masked]>
Date: Wed, 04 Dec 2024 09:21:40 +0900

Jonathan Tan <[email-masked]> writes:

> Junio C Hamano <[email-masked]> writes:
>> > The fix slows down a fetch from a certain repo at
>> > $DAYJOB from 2m2.127s to 2m45.052s, but in order to make the fetch
>> > correct, it seems worth it.
>> 
>> And "the fix" is not described so a reader is left wondering.  Is
>> the fix for an oversight of not checking merely to check it?  IOW,
>> is
>> 
>>     c08589efdc made outgoing links to be checked for commits, but
>>     failed to do so for trees.  Make sure we check both
>> 
>> what is happening?
>
> Yes. I was trying to keep to the character limit and in doing so, made
> the commit message title hard to understand. I think the new title
> should be easier to understand (and also stated explicitly in the commit
> message what is being taught to Git).

Thanks.

>> > However, it is also possible for
>> > the server to compute that it needs to send S and not O, and proceed
>> > from there;
>> 
>> If O, C, and S have all identical trees, then wouldn't such a test
>> work well?  At that point it does not matter which between O and C 
>> the server bases its decision to send S but not S's tree on, no?
>> 
>> In any case, will queue.  Thanks.
>
> O has a different tree from C and S. I will add a note to clarify this.

No, that is not what I meant.  "If you arrange your test so that all
three have the same tree, then would't the reason why such a test
would not work you cited disappear and make this fix testable?" is
what I wanted to ask.